// ASocketDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ASocketDemo.h"
#include "ASocketDemoDlg.h"
#include "DlgProxy.h"


#include <atlconv.h>
#include <tchar.h>

#define _A2W(dst,src) AtlA2WHelper(dst,src,lstrlenA(src)+1)
#define _W2A(dst,src) AtlW2AHelper(dst,src,lstrlenW(src)+1)


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CASocketDemoDlg dialog

IMPLEMENT_DYNAMIC(CASocketDemoDlg, CDialog);

CASocketDemoDlg::CASocketDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CASocketDemoDlg::IDD, pParent)
{
	HRESULT		hr;

	//{{AFX_DATA_INIT(CASocketDemoDlg)
	m_Output = _T("");
	m_Result = _T("");
	m_Command = _T("guest");
	m_HostName = _T("library.uah.edu");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
	m_pSocket = NULL;
	hr = CoCreateInstance(CLSID_Socket, NULL, CLSCTX_INPROC_SERVER, IID_ISocket, (void**) &m_pSocket);
	if( ! SUCCEEDED( hr ) )
	{
		m_pSocket = NULL;	
		return;
	}

	m_pSocket->put_Protocol( 2 );	// Telnet protocol
}

CASocketDemoDlg::~CASocketDemoDlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CASocketDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CASocketDemoDlg)
	DDX_Text(pDX, IDC_OUTPUT, m_Output);
	DDX_Text(pDX, IDC_RESULT, m_Result);
	DDX_Text(pDX, IDC_COMMAND, m_Command);
	DDX_Text(pDX, IDC_HOST, m_HostName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CASocketDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CASocketDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_SUBMIT, OnSubmit)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CASocketDemoDlg message handlers

BOOL CASocketDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	SetTimer( 1, 1000, NULL );
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CASocketDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CASocketDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CASocketDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CASocketDemoDlg::OnClose() 
{
	if (CanExit())
		CDialog::OnClose();
}

void CASocketDemoDlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CASocketDemoDlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CASocketDemoDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

void CASocketDemoDlg::OnConnect() 
{
	CHAR	szMsg[ 256 ];
	LONG	lLastError;
	WCHAR	wszTemp[ 1023 + 1 ];
	BSTR	pHostName;


	if( m_pSocket == NULL )
	{	
		m_Result = "CoCreateInstance failed";
		UpdateData( FALSE );
		return;
	}

	UpdateData( TRUE );

	m_Result = "Please wait...";
	UpdateData( FALSE );

	_A2W( wszTemp, ( LPCTSTR ) m_HostName  );
	pHostName = SysAllocString( (OLECHAR FAR *) wszTemp );
	m_pSocket->Connect( pHostName, 23 );
	m_pSocket->get_LastError( &lLastError );

	if( lLastError == 0 )
		wsprintf( szMsg, "Connect: SUCCESS" );
	else
		wsprintf( szMsg, "Connect: ERROR %ld", lLastError );
	m_Result = szMsg;
	UpdateData( FALSE );

	SysFreeString( pHostName );	
}

void CASocketDemoDlg::OnDisconnect() 
{
	CHAR	szMsg[ 256 ];
	LONG	lLastError;

	if( m_pSocket == NULL )
	{	
		m_Result = "CoCreateInstance failed";
		UpdateData( FALSE );
		return;
	}

	m_Result = "Please wait...";
	UpdateData( FALSE );

	m_pSocket->Disconnect();
	m_pSocket->get_LastError( &lLastError );

	if( lLastError == 0 )
		wsprintf( szMsg, "Disconnect: SUCCESS" );
	else
		wsprintf( szMsg, "Disconnect: ERROR %ld", lLastError );

	m_Result = szMsg;
	UpdateData( FALSE );
}

void CASocketDemoDlg::OnSubmit() 
{
	CHAR	szMsg[ 256 ];
	LONG	lLastError;
	WCHAR	wszTemp[ 1023 + 1 ];
	BSTR	pCommand;
	CString	cstrCommand;


	if( m_pSocket == NULL )
	{	
		m_Result = "CoCreateInstance failed";
		UpdateData( FALSE );
		return;
	}

	UpdateData( TRUE );

	m_Result = "Please wait...";
	UpdateData( FALSE );

	cstrCommand  = ( LPCTSTR ) m_Command;
	cstrCommand += "\r\n";

	_A2W( wszTemp, ( LPCTSTR ) cstrCommand  );
	pCommand = SysAllocString( (OLECHAR FAR *) wszTemp );

	m_pSocket->SendData( pCommand );
	m_pSocket->get_LastError( &lLastError );

	if( lLastError == 0 )
		wsprintf( szMsg, "SendData: SUCCESS" );
	else
		wsprintf( szMsg, "SendData: ERROR %ld", lLastError );

	m_Result = szMsg;
	UpdateData( FALSE );

	SysFreeString( pCommand );	

	Sleep( 1000 );
}




void CASocketDemoDlg::OnTimer(UINT nIDEvent) 
// Receive data
{
	BSTR	pString;
	CHAR	szBuffer[ 8192 ] = {0};
	LONG	lConnectionState;

	if( m_pSocket == NULL )
	{	
		m_Result = "CoCreateInstance failed";
		UpdateData( FALSE );
		return;
	}

	m_pSocket->get_ConnectionState( &lConnectionState );
	if( lConnectionState != 3 )	// 1=asCONN_DISCONNECTED, 2=asCONN_LISTENING, 3=asCONN_CONNECTED
	{
		return;
	}

	UpdateData( TRUE );
	m_pSocket->ReceiveData( &pString );
	_W2A( szBuffer, pString );
	if( szBuffer[ 0 ] != '\0' )
	{
		m_Output += szBuffer;
		m_Result = "";
		UpdateData( FALSE );
	}

 
	CDialog::OnTimer(nIDEvent);
}
