// ASocketDemoDlg.h : header file
//

#if !defined(AFX_ASOCKETDEMODLG_H__4712354A_1099_11D6_AAFB_005056C00001__INCLUDED_)
#define AFX_ASOCKETDEMODLG_H__4712354A_1099_11D6_AAFB_005056C00001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "asocket_i.c"
#include "asocket.h"

class CASocketDemoDlgAutoProxy;

/////////////////////////////////////////////////////////////////////////////
// CASocketDemoDlg dialog

class CASocketDemoDlg : public CDialog
{
	DECLARE_DYNAMIC(CASocketDemoDlg);
	friend class CASocketDemoDlgAutoProxy;

// Construction
public:
	CASocketDemoDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CASocketDemoDlg();

	ISocket		*m_pSocket;

// Dialog Data
	//{{AFX_DATA(CASocketDemoDlg)
	enum { IDD = IDD_ASOCKETDEMO_DIALOG };
	CString	m_Output;
	CString	m_Result;
	CString	m_Command;
	CString	m_HostName;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CASocketDemoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CASocketDemoDlgAutoProxy* m_pAutoProxy;
	HICON m_hIcon;

	BOOL CanExit();

	// Generated message map functions
	//{{AFX_MSG(CASocketDemoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	afx_msg void OnSubmit();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ASOCKETDEMODLG_H__4712354A_1099_11D6_AAFB_005056C00001__INCLUDED_)
